package search.util;
import java.util.NoSuchElementException;
import java.util.Comparator;
import search.util.Queue;

/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 24.06.2003
 * Time: 15:12:42
 * To change this template use Options | File Templates.
 */
public class PriorityQueue implements Queue{

protected node first = null;
protected Comparator cmp;


public class node{
    protected Object content;
    protected node next;



public node(Object p){
    this.content=p;
}
public node(Object p, node next) {
    this.content = p;
    this.next = next;
}

}



 public PriorityQueue(Comparator cmp){
        this.cmp =cmp;
  }

public void put(Object p) {
    node nnode = new node(p);
    if (first == null) {
        first = nnode;
    }
    else {
        node position = first;
        if (cmp.compare(p, position.content) <= 0) {
            first = new node(p,first);
        }
        else {
        while (position.next != null && (cmp.compare(p, position.next.content) >= 0)) {
                position = position.next;
        }
             position.next = new node(p,position.next);
        }
    }
}

public Object get() {
    if(isEmpty()) return new NoSuchElementException("Queue empty");
    Object temp = first.content;
    first=first.next;
    return temp;
    }

public boolean isEmpty() {
        return (first==null)? true : false;
    }

public void clear() {
    first =null;


}

}