/*
 * File TreeNode.java.
 * Created on 12.05.2003
 */
package search.util;

import java.util.List;

/**
 * Schnittstelle von Klassen fr Baumknoten, die
 * ausschlielich die Inspektion der Baumstruktur und seiner Werte
 * gestattet.
 * 
 * @author Erich Ehses
 */
public interface TreeNode {
    
    /**
     * Gibt die Liste der Kindknoten zurck.
     * @return Liste der Kindknoten.
     */
    public List getChildren();
    
    /**
     * Gibt den im Knoten gespeicherten Inhalt zurck.
     * @return Knoteninhalt.
     */
    public Object getValue();
}
