/*
 * File TreeAlgorithms.java.
 * Created on 09.05.2003
 */
package search.util;

import java.util.Iterator;
import java.util.List;

/**
 * Verschiedene Algorithmen auf Bumen.
 * @author Erich Ehses
 */
public final class TreeAlgorithms {
    private TreeAlgorithms() {}

    /**
     * Bestimmt die Anzahl der inneren Knoten eines Baumes.
     * 
     * @param root Wurzel des (Teil-) Baums.
     * @return Anzahl der inneren Knoten.
     */
    public static int numberOfInnerNodes(TreeNode root) {
        List nodes = root.getChildren();
        Iterator iter = nodes.iterator();
        int counter = 0;
        //kew
        if (!nodes.isEmpty()) {counter=1;}
        //end kew
        while (iter.hasNext()) {
            counter++;
            counter = counter + numberOfInnerNodes((TreeNode)iter.next());
        }
        return counter; // DAS IST DIE FALSCHE ANTWORT
    }
    
    /**
     * Druckt den Baum in Preorderreihenfolge aus.
     * Jede Baumebene wird jeweils um 4 weitere Leerzeichen eingerckt.
     * @param root Wurzel des (Teil-) Baums.
     * @param shift Anzahl der Leerzeichen mit denen der Knoten eingerckt
     *        werden soll
     */
    public static void printTree(TreeNode root, int shift) {
        // Das ist die Zusatzaufgabe !!
    }
}
